;APS00000141000001410000014100000141000001410000014100000141000001410000014100000141
;////////////////////////////////////////////////////////////////////////////
;// Main Code for the #Amycoders TextureCompo.
;// Coded by E-Moon/Endzeit

ASMONE	equ	1				; 1 = ShowSize in AsmOne

		Section	Start,Code
						; 0 = No SizeShow
		jmp	Start

		incdir	"Sources:_TxtCompo/"	; Set your own dir here.
		include	"bmp.i"

		Section	Code,Code
Start	
		lea	TextureBuffer,a0
		jsr	GenerateTexture		; Generate Texture

		lea	TextureBuffer,a0
		jsr	SaveBmpFile		; Save down the file.
		rts	



; Texture generate routine by Aln!/Appendix+Mawi (02.05.99)
; Especially for #amycoders TextureCompo
;
; Wormholes


GenerateTexture

GRID = 6
MASKSTART = 0
MASKLOOP = 1

	move.l	#$f8fcfc,d0		; mask
	move.l	d0,a5			; seed


; randomize table

	moveq	#-1,d5
.FillLoop:
	IFEQ	MASKSTART-1
		move.l	(a5)+,(a0)	; mask data
		and.l	d0,(a0)+
	ELSE
		move.l	(a5)+,(a0)+	; don't mask data
	ENDIF
	dbra	d5,.FillLoop



; main loop

	moveq	#1<<GRID,d1		; deltaAX
	sub.w	a1,a1			; deltaAY
	moveq	#0,d2			; deltaBX
	move.w	#1<<(8+GRID),a2		; deltaBY

	moveq	#GRID*2,d6		; how many loops
.MainLoop:

	move.b	d1,d3
	sub.b	d2,d3
	asr.b	#1,d3			; deltaCX <- (deltaAX-deltaBX)/2
	move.w	a1,d4
	sub.w	a2,d4
	asr.w	#1,d4
	move.w	d4,a3			; (deltaAY-deltaBY)/2=deltaCY
	
	clr.l	d7			; we need less than 256 iterations
.LoopB:					; but who cares :) (actually it does
					; not matter that we'll do too much
	swap	d7			; iterations)
.LoopA:
	move.l	(a0,d5.l*4),d4		; P  deltaA   Q
					;  o---------o
	add.b	d1,d5			;  |\       /|
	add.w	a1,d5			;  | \     / |d
	add.l	(a0,d5.l*4),d4		;  |  \   /  |e
					;  |   \T/   |l
	add.b	d2,d5			;  |   Co    |t
	add.w	a2,d5			;  |  l/ \   |a
	add.l	(a0,d5.l*4),d4		;  | e/   \  |B
					;  |d/     \ |
	sub.b	d1,d5			;  |/       \|
	sub.w	a1,d5			;  o---------o
	add.l	(a0,d5.l*4),d4		; S           R

	lsr.l	#2,d4			;    T=(P+Q+R+S)/4
	IFEQ	MASKLOOP-1
		and.l	d0,d4		; and of course we should mask it
	ENDIF

	add.b	d3,d5
	add.w	a3,d5
	move.l	d4,(a0,d5.l*4)		; set T

	add.b	d3,d5
	add.w	a3,d5
	subq.b	#1,d7
	bne.b	.LoopA


	add.b	d2,d5
	add.w	a2,d5
	swap	d7
	subq.b	#1,d7
	bne.b	.LoopB


	move.b	d3,d2
	neg.b	d2			; deltaBX <- -deltaCX
	sub.w	a2,a2
	sub.w	a3,a2			; deltaBY <- -deltaCY

	add.b	d2,d1			; deltaAX <- deltaAX-deltaCX=(deltaBX-deltaAX)/2
	add.w	a2,a1			; deltaAY <- deltaAY-deltaCY=(deltaBY-deltaAY)/2

	subq.w	#1,d6
	bne.b	.MainLoop




.EndGenerate
		rts

	IFNE	ASMONE
		printt "Code Size:"
		printv	.EndGenerate-GenerateTexture
	ENDC	


TextureName	dc.b	"texture.bmp",0,0,0,0

		section	Texturebuffer,bss

TextureBuffer	ds.l	256*256

